/////////////////////////////////////////////////////////////////////////////
// FiltresVideo.cpp
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2000-2002 Grincheux  All rights reserved.
/////////////////////////////////////////////////////////////////////////////
//
//	This file is subject to the terms of the GNU General Public License as
//	published by the Free Software Foundation.  A copy of this license is
//	included with this software distribution in the file COPYING.  If you
//	do not have a copy, you may obtain a copy by writing to the Free
//	Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
//
//	This software is distributed in the hope that it will be useful,
//	but WITHOUT ANY WARRANTY; without even the implied warranty of
//	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//	GNU General Public License for more details
/////////////////////////////////////////////////////////////////////////////
//
// This software was based on MultiDec 5.9 Those portions are
// Copyright (C) 1999/2000 Espresso (echter_espresso@hotmail.com)
//
/////////////////////////////////////////////////////////////////////////////
#include <windows.h>       // required for all Windows applications
#include <stdio.h>

#include "general.h"


int nYUVThreshold, nUThreshold, nVThreshold, iLine, nPixThreshold;

const __int64 nMaskeU  = 0x0000FF000000FF00; //Grincheux
const __int64 nMaskeV  = 0xFF000000FF000000; //Grincheux
const __int64 nMaskeUV = 0xFF00FF00FF00FF00;

int NbFramesManquantes();
int TestCorrectionUV(DWORD *pQuelle, DWORD *pSauve, DWORD *pColorQuelle, DWORD MasqueUV);
int LineSaturation(DWORD *pQuelle, int CountX, int iLine_bugne, int iLine_sort, int Zone2_bugne);

// -------------------------------------------------------------
// Grincheux 27/05/2001
// a) progrs important du filtrage bleu sur la zone infrieure :
// caractrisation de leur apparition SANS recourir au test de saturation
// des couleurs >> plus d'erreur de dtection sur la partie bugne bleu/violette infrieure
// mme sur des images fortement colores.

// nouvelle mthode de FASOUIL  de dtermination de type image   
// ***** >>>>ABANDONNE ***** progrs secondaire sur le rephasage anti-bavure automatique li  a):
// ***** >>>>ABANDONNE ***** on n'effectue le test de rephasage qu'en cas d'apparition
// ***** >>>>ABANDONNE ***** lignes bleues en a)

// -------------------------------------------------------------
// Grincheux Modififications du Filtres KizKoool SECAM v3.2
// a)filtrage violette avant et aprs destroumpfage sur seulement
// 1/4 des lignes

// b) Sur 2 zones, filtrage par bloc avec un seuil de lignes bugnes
// pour diminuer fausse dtection

// ***** nouvelle mthode de FASOUIL  de dtermination de type image   
// ***** >>>>ABANDONNE : rephasage antibavure amliore par meilleure localisation des lignes bugnes testes

// ------------------------------------------------------------
// Filtres KizKoool SECAM v3.2
//
// Filtre lignes violettes + filtre anti-bavures
//
// Premires fonctions de traitement SECAM par Fantasio
// Ancien filtre bleu ASM par 1konnu
//
// Nouvel algorithme de dtection des lignes satures + bugfixes +
// traduction en C du filtre bleu et optimisations par KizKoool
//
// Ide et code original du filtre anti-bavures par 1Konnu
//
// Adaptation  K!TV + optimisations +

// ***** nouvelle mthode de FASOUIL  de dtermination de type image   
// ***** >>>>>ABANDONNE : rephasage dynamique du filtre anti-bavures par KizKoool

// Ide de l'exploitation de la variable CurrentFrame par E-nek
// Symbiose optimale des 2 filtres par Grincheux et KizKoool
//--------------------------------------------------------------



void SecamFiltering(DWORD **pLinesAddress, int *pSortLines)
{
	// Taille maximale d'une frame 768*287
	static BYTE ColorBackup[768 * ZEILENZAHL];
	BYTE *pColorQuelle, *pColorBuffer, *pQuelle, *pSource, *pix_courant;

	//Grincheux
	int pSortLines_inverse[ZEILENZAHL]; //,saturee2;
	BOOL Zone2_bugne=0;//Grincheux

	//Grincheux : inverse de pSortLines
	for (iLine=0; iLine <ZEILENZAHL; iLine++)
	{
		pSortLines_inverse[pSortLines[iLine]]=iLine;
	}

	nPixThreshold= (int) ((CurrentX*iPixFilterThreshold)/200);


	if (bFilterBlueLines)
	{
		//Grincheux : 2 me zone, dtection bloc bugn AVANT dstroumpf
		// *************** nouveau test de dtection indpendant des seuils U et V *********
		if (((TypeImage_test1>30)&&(Zone2_test2>3))||((TypeImage_test2>30)&&(Zone2_test1>3))) 
			{
			Zone2_bugne=1;
			}
			else 
			{
			Zone2_bugne=0;
			}
		// *************** nouveau test de dtection indpendant des seuils U et V *********
	
		//***********ancienne methode test de saturation de la bande
	/*	
		saturee2=0;
		Zone2_bugne=0;
	
	for (iLine=32; iLine <58; iLine++)
		{
			if (LineSaturation((DWORD *)pLinesAddress[iLine], CurrentX>>1,0,0,0))
			//utilise la test de saturation "standard" par KIZKOOOL
			{
				saturee2++;
			}
		}

		if (saturee2>8) // Bloc sature
		{
			Zone2_bugne=1;
		}
	/*/	
		//******************************
	} // fin if bFilterBlueLines

	_asm movq mm7, nMaskeUV


	// fameuse boucle KIZKOOL et GRINCHEUX  OPTIMALE pour bavure+bleu
	for (iLine=(!VideoPlugin.DeInterlace)+VideoPlugin.MovieBoost*(!VideoPlugin.DeInterlace); iLine < ZEILENZAHL-VideoPlugin.MovieBoost*(!VideoPlugin.DeInterlace); iLine++)
	{
	// pQuelle: pointeur sur la ligne source dans l'image dcode:
	pQuelle = (BYTE*) pLinesAddress[pSortLines[iLine]];
	// pColorBuffer: pointeur sur les couleurs non satures du buffer
	pColorBuffer = (BYTE*) (ColorBackup + CurrentX * iLine);

		//Grincheux : test de saturation de la ligne, fonction modifie
		if (bFilterBlueLines && (LineSaturation(pLinesAddress[pSortLines[iLine]], CurrentX>>1,pSortLines[iLine],iLine,Zone2_bugne)))
		{
			// Ligne sature
			// Restauration de la saturation  partir du buffer de lignes non satures
			for (pix_courant=pQuelle+1; pix_courant<pQuelle+(CurrentX<<1); pix_courant=pix_courant+4)
			{
				*pix_courant=*pColorBuffer;
				*(pix_courant+2)=*(pColorBuffer+1);
				pColorBuffer=pColorBuffer+2;
			}
		}
		else
		{
			// Ligne non sature ou pas de filtre bleu
			// 1) Application du filtre anti-bavures

			if(iLine!=(!VideoPlugin.DeInterlace)+VideoPlugin.MovieBoost*(!VideoPlugin.DeInterlace))
			{
				// pColorQuelle: pointeur sur la ligne precedente dans l'image dcode:
				pColorQuelle=(BYTE*)pLinesAddress[pSortLines[iLine-1]];

				if ((((iLine%2)==0) && TypeImage) || (((iLine%2)!=0) && !TypeImage))
				{
					// ligne paire de l'image de type 1 ou ligne impaire de l'image de type 2
					pSource=pQuelle+3;
					for (pix_courant=pColorQuelle+3; pix_courant<pColorQuelle+(CurrentX<<1); pix_courant=pix_courant+4)
					{
						*pSource=*pix_courant;
						pSource=pSource+4;
					}
				}
				else
				{
					// ligne impaire de l'image de type 1 ou ligne paire de l'image de type 2
					pSource=pQuelle+1;
					for (pix_courant=pColorQuelle+1; pix_courant<pColorQuelle+(CurrentX<<1); pix_courant=pix_courant+4)
					{
						*pSource=*pix_courant;
						pSource=pSource+4;
					}
				}
			}

			// 2) Stockage de la ligne dans le buffer de lignes non satures
			if (bFilterBlueLines)
				/*
				for (pix_courant=pQuelle+1; pix_courant<pQuelle+(CurrentX<<1); pix_courant=pix_courant+4)
				{
					*pColorBuffer= *pix_courant;
					*(pColorBuffer+1)= *(pix_courant+2);
					pColorBuffer=pColorBuffer+2;
				}
				/*/
		// Grincheux : traduction en ASM MMX plus rapide que c++
		// (-1% cpu en moins sur celeron 450 mhz)
		_asm {
	//		pushad
			mov edi,pColorBuffer  //zone stockage
			mov eax,CurrentX

			mov esi,pQuelle       //encours
			mov edx,eax
			shr eax,2
			and edx,3
			
			jz PixSui3
			movq mm0,qword ptr [esi] //mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
			//pand mm0,mm7 //maskeUV V2 00 U2 00 V0 00 U0 00
			add esi, edx
			psrlw mm0,8 //0 V2 0 U2 0 V1 0 U1
			
			add esi, edx
			packuswb mm0, mm0 //V2U2V1U1V2U2V1U1
			
			movd dword ptr [edi], mm0
			
			add edi, edx
			// fin traitement des edx points

			align 16
		PixSui3:  // boucle pour stocker les points restants (multiples de 4)
			movq mm0,qword ptr [esi] //mm0 = V2 Y3 U2 Y2 V0 Y1 U0 Y0
			//pand mm0,mm7 //maskeUV V2 00 U2 00 V0 00 U0 00
			
			add edi,4
			psrlw mm0,8 //0 V2 0 U2 0 V1 0 U1
			
			add esi,8
			packuswb mm0, mm0 //V2U2V1U1V2U2V1U1
			
			dec eax

			movd dword ptr [edi-4], mm0
			jg PixSui3

			emms
//			popad
			} // fin asm
		} // fin de else
	} // boucle for


} // fin void SecamFiltering




// Grincheux : Fonction dtection lign sature, modifie pour filtrage par zone
// Zone 1 de ligne 0  21 image stroumpfe
// Zone 2 de ligne 32  51 image stroumpfe
// Zone 4 de ligne ZEILENZAHL-32  ZEILENZAHL-1 image dstroumpfe
// Paramtres:
// pQuelle: Pointeur vers la ligne  tester
// CountX: Nombre de pixels  tester
// iLine_bugne : position ligne dans image non dschtroumpfe
// iLine_sort : position ligne dans image dschtroumpfe
// Zone2_bugne : flag indiquant si tout le bloc de lignes Zone 2 est schtroumpf
int LineSaturation(DWORD *pQuelle, int CountX, int iLine_bugne, int 
iLine_sort, int Zone2_bugne)
{
	DWORD *pix_courant;
	long U, V, Y, Seuil_NbPix;

if ((iLine_bugne<25) || (nb_ligne_noire>170)) //Grincheux : 1 ere zone, dtection bugne AVANT dstroumpf
//if ((iLine_bugne<22) || (nb_ligne_noire>170)) //Grincheux : 1 ere zone, dtection bugne AVANT dstroumpf
//si nb_ligne_noire>170 on rebascule en test saturation KizKoool sur la totalit de l'image pour viter 
//rapparition lignes bleues lies au mauvais desctroumpfage  cause des nombreuses lignes noires faussant le test corrlation nagra 
{

		
	//if  ((Zone2_bugne==1)&&(nb_ligne_noire<=170))
	//{
	//	return (1>0);
	//}
	//else
		{
			// Test de saturation de ligne par KizKoool
			Seuil_NbPix=nPixThreshold;
			pix_courant=pQuelle;
			while ((pix_courant<pQuelle+CountX) && (Seuil_NbPix>0))
			{
				U = *pix_courant>>8 & 0xff;
				V = *pix_courant>>24 & 0xff;
				Y = ((*pix_courant>>16 & 0xff)+(*pix_courant & 0xff))>>2;

				if ( !((((U>>1)+V)>Y+nYUVThreshold) && ((U>nUThreshold) || (V>nVThreshold))) )
				{
					Seuil_NbPix-=1;
				}
				pix_courant++;
			}
			return (Seuil_NbPix>0);
		}
	
}
else
	{
	// Modif : car de temps en temps bouffes de ligne bugnes de 52  59 en +
	//if ((iLine_bugne>31) && (iLine_bugne<52)) 
	if ((iLine_bugne>31) && (iLine_bugne<59))
		{
		return (Zone2_bugne);
		}
	else
		{
			if (iLine_sort>=ZEILENZAHL-32)
				{
				return ((iLine_sort%2!=iLine_bugne%2)); 
				}
			else
				{
				return (1<0);
				}
		}
	}

}

/*
//
// Rephasage dynamique du filtre anti-bavures par KizKoool
// Algorithme bas sur les proprits des lignes satures
//
void FindFrameType(DWORD **pLinesAddress, int *pSortLines)
{
	DWORD *pQuelle, *pColorQuelle,*pLineBackup;
	static DWORD LineColorBackup[768];
	unsigned long MasqueToutSaufU, MasqueToutSaufV;
	int nb_saturees1, nb_saturees2;
	int pSortLines_inverse[ZEILENZAHL]; //Grincheux
	nb_saturees1=0;
	nb_saturees2=0;

	MasqueToutSaufU = 0xFFFF00FF;	// Garde tout sauf la composante U
	MasqueToutSaufV = 0x00FFFFFF;	// Garde tout sauf la composante V


	// Dtection des frames loupes
	//Grincheux, la synchro NbFramesManquantes() se fait au niveau de DoStuff()
	//if (NbFramesManquantes()%2==1)TypeImage=!(TypeImage);
	if ((pSortLines[ZEILENZAHL-1])%2!=(ZEILENZAHL-1)%2)
	// Grincheux : Dtection simple et trs sure des lignes bugnes infrieures
	// on ne cale la phase que quand il y a des lignes bugnes
	// plus rapide et moins d'erreur

	{
	pLineBackup = (DWORD*) LineColorBackup;
	nPixThreshold = (int) ((CurrentX*iPixFilterThreshold)/200);

	//Grincheux : inverse de pSortLines
	for (iLine=0; iLine <ZEILENZAHL; iLine++)
	{
		pSortLines_inverse[pSortLines[iLine]]=iLine;
	}

	//modif Grincheux : slection plus prcises des lignes bugnes  tester
	for (iLine=ZEILENZAHL-15; iLine < ZEILENZAHL; iLine++)
	{
		if (((pSortLines[iLine]+1)<ZEILENZAHL)&&(pSortLines_inverse[pSortLines[iLine]+1]<ZEILENZAHL-32)) 
		// Grincheux
		{
			pQuelle = (DWORD*) pLinesAddress[pSortLines[iLine]+1]; //modifi Grincheux
			pColorQuelle = (DWORD*)
			pLinesAddress[pSortLines[pSortLines_inverse[pSortLines[iLine]+1]-1]];

			if (((((pSortLines_inverse[pSortLines[iLine]+1])%2)==0) && TypeImage) || ((((pSortLines_inverse[pSortLines[iLine]+1])%2)!=0) && !TypeImage)) 
			//modifi Grincheux
			{
				// ligne paire de l'image de type 1
				// ou ligne impaire de l'image de type 2
				nb_saturees1+=TestCorrectionUV(pQuelle, pLineBackup, pColorQuelle, MasqueToutSaufV);
				nb_saturees2+=TestCorrectionUV(pQuelle, pLineBackup, pColorQuelle, MasqueToutSaufU);
			}
			else
			{
				// ligne impaire de l'image de type 1
				// ou ligne paire de l'image de type 2
				nb_saturees1+=TestCorrectionUV(pQuelle, pLineBackup, pColorQuelle, MasqueToutSaufU);
				nb_saturees2+=TestCorrectionUV(pQuelle, pLineBackup, pColorQuelle, MasqueToutSaufV);
			}
		}
	}

	// Test de rephasage

	if ((nb_saturees1>nb_saturees2+4) && (min(nb_saturees1,nb_saturees2)<4))
		TypeImage=!(TypeImage);
	}
}//*/


#define LIGNES_TEST_PHASE 288


// E-nek 19/10/2001
// Detection du type de frame bas sur la proprit du signal SECAM:
// Le signal envoy contient Y et soit U ou V. le Tuner se charge ensuite
// de reconstituer le pixel YUV en prenant le U ou V de la ligne prcdente.

// Ligne 	Transmis 	Reconstitu par Tuner
// 1		Y1_U1		Y1_U1_VX
// 2		Y2_V2		Y2_U1_V2 (U1 = U ligne1)
// 3		Y3_U3		Y3_U3_V2 (V2 = V ligne2)
// 4		Y4_V4		Y4_U3_V4 ...
// 5		Y5_U5		Y5_U5_V4 ...
//
// Il existe donc deux types de trames, ce qui correspond  notre TypeImage .
// On essaie ici de dterminer si la trame est de type UV-UV-UV ou VU-VU-VU

// Remarque :
// Un grand merci  Fasouil pour avoir partag sa "trouvaille".
// TODO:
// Ce code devrait etre rendu plus robuste ...

void FindFrameType(DWORD **pLinesAddress, int *pSortLines)
{
	int py;
	short * pLine;
	//BYTE donnee[LIGNES_TEST_PHASE];
	BYTE donnee0_u0,donnee0_v0,donnee1_u0,donnee1_v0;
	BYTE donnee0_u1,donnee0_v1,donnee1_u1,donnee1_v1;
	BYTE donnee0,donnee1;

	int  NbTest0_u1, NbTest0_u2, NbTest0_v1, NbTest0_v2;	
	int  NbTest1_u1, NbTest1_u2, NbTest1_v1, NbTest1_v2;
	int  NbTest1,NbTest2,Somme_ctrl;

	NbTest1 = NbTest2=Somme_ctrl=0;
	pLine = (short *) pLinesAddress[52];
	pLine=pLine+((CurrentX/4)) *2;
	donnee0 = (BYTE) ((*pLine) >> 8);
	for (py=53;py <LIGNES_TEST_PHASE; py ++) //vite les premieres lignes pouvant tre bugnes
	{
		pLine = (short *) pLinesAddress[py];
		pLine=pLine+((CurrentX/4)) *2;
		donnee1 = (BYTE) ((*pLine) >> 8);

		if (donnee0==donnee1)
			{
			if ((py-1)%2==0) NbTest1 ++;
			else NbTest2 ++;
			}
		donnee0=donnee1;
	}
 
	TypeImage = (NbTest1 > NbTest2);
	
	//*********************************************
	// fonction suivante permet de tester si la seconde zone est bugne
	TypeImage_test2=NbTest2; //pas trs propre, car TypeImage_test2 utilis par le filtre bleu  
	TypeImage_test1=NbTest1; //idem 
//************************************************	
	NbTest1 = NbTest2 = 0;
	NbTest0_u1=NbTest0_u2=NbTest0_v1=NbTest0_v2=0;	
	NbTest1_u1=NbTest1_u2=NbTest1_v1=NbTest1_v2=0;


	pLine = (short *) pLinesAddress[0];
	donnee0_u0=(BYTE) ((*pLine) >> 8);
	donnee0_v0=(BYTE) ((*pLine) >> 24);

	pLine=pLine+((CurrentX/4)) *2;
	donnee1_u0=(BYTE) ((*pLine) >> 8);
	donnee1_v0=(BYTE) ((*pLine) >> 24);


	for (py=1;py <33; py ++)  //zone 1 		
	{
		pLine = (short *) pLinesAddress[py];
		donnee0_u1=(BYTE) ((*pLine) >> 8);
		donnee0_v1=(BYTE) ((*pLine) >> 24);

		pLine=pLine+((CurrentX/4))*2;
		donnee1_u1=(BYTE) ((*pLine) >> 8);
		donnee1_v1=(BYTE) ((*pLine) >> 24);

		if (donnee0_u1==donnee0_u0)
			{
			if ((py-1)%2==0) NbTest0_u1 ++;
			else NbTest0_u2 ++;
			}
		donnee0_u0=donnee0_u1;
	
		
		if (donnee1_u1==donnee1_u0)
			{
			if ((py-1)%2==0) NbTest1_u1 ++;
			else NbTest1_u2 ++;
			}
		donnee1_u0=donnee1_u1;
	
		if (donnee0_v1==donnee0_v0)
			{
			if ((py-1)%2==0) NbTest0_v1 ++;
			else NbTest0_v2 ++;
			}
		donnee0_v0=donnee0_v1;
	
		
		if (donnee1_v1==donnee1_v0)
			{
			if ((py-1)%2==0) NbTest1_v1 ++;
			else NbTest1_v2 ++;
			}
		donnee1_v0=donnee1_v1;
	}
	


	if ((NbTest0_u1>13)&&(NbTest0_v1>13)&&(NbTest1_u1>13)&&(NbTest1_v1>13)) Zone1_test1=15;
	else Zone1_test1=8;
	if ((NbTest0_u2>13)&&(NbTest0_v2>13)&&(NbTest1_u2>13)&&(NbTest1_v2>13)) Zone1_test2=15;
	else Zone1_test2=8;
	
	if ((Zone1_test2>14)&&(Zone1_test1<10)) Zone1_test1=0; //correction fausse erreur
	if ((Zone1_test1>14)&&(Zone1_test2<10)) Zone1_test2=0; //correction fausse erreur
	

//************************************************
	NbTest1 = NbTest2 = 0;
	NbTest0_u1=NbTest0_u2=NbTest0_v1=NbTest0_v2=0;	
	NbTest1_u1=NbTest1_u2=NbTest1_v1=NbTest1_v2=0;


	pLine = (short *) pLinesAddress[32];
	donnee0_u0=(BYTE) ((*pLine) >> 8);
	donnee0_v0=(BYTE) ((*pLine) >> 24);

	pLine=pLine+((CurrentX/4)) *2;
	donnee1_u0=(BYTE) ((*pLine) >> 8);
	donnee1_v0=(BYTE) ((*pLine) >> 24);


	for (py=33;py <53; py ++)  //zone 1 		
	{
		pLine = (short *) pLinesAddress[py];
		donnee0_u1=(BYTE) ((*pLine) >> 8);
		donnee0_v1=(BYTE) ((*pLine) >> 24);

		pLine=pLine+((CurrentX/4))*2;
		donnee1_u1=(BYTE) ((*pLine) >> 8);
		donnee1_v1=(BYTE) ((*pLine) >> 24);

		if (donnee0_u1==donnee0_u0)
			{
			if ((py-1)%2==0) NbTest0_u1 ++;
			else NbTest0_u2 ++;
			}
		donnee0_u0=donnee0_u1;
	
		
		if (donnee1_u1==donnee1_u0)
			{
			if ((py-1)%2==0) NbTest1_u1 ++;
			else NbTest1_u2 ++;
			}
		donnee1_u0=donnee1_u1;
	
		if (donnee0_v1==donnee0_v0)
			{
			if ((py-1)%2==0) NbTest0_v1 ++;
			else NbTest0_v2 ++;
			}
		donnee0_v0=donnee0_v1;
	
		
		if (donnee1_v1==donnee1_v0)
			{
			if ((py-1)%2==0) NbTest1_v1 ++;
			else NbTest1_v2 ++;
			}
		donnee1_v0=donnee1_v1;
	}
	


	if ((NbTest0_u1>3)&&(NbTest0_v1>3)&&(NbTest1_u1>3)&&(NbTest1_v1>3)) Zone2_test1=NbTest0_u1;
	else Zone2_test1=0;
	if ((NbTest0_u2>3)&&(NbTest0_v2>3)&&(NbTest1_u2>3)&&(NbTest1_v2>3)) Zone2_test2=NbTest0_u2;
	else Zone2_test2=0;

	UNREFERENCED_PARAMETER( pSortLines);

}	



//
// Dtection des frames manquantes par KizKoool
// Sur une ide d'exploiter la variable CurrentFrame d'E-nek
//
// Valeur de retour:
// Nombre de frames non acquises
//
int NbFramesManquantes()
{
	static int PrecedentFrame=-1;
	int NbFramesLoupees;

	if (CurrentFrame>PrecedentFrame)
		NbFramesLoupees=CurrentFrame-PrecedentFrame-1;
	else
		NbFramesLoupees=CurrentFrame-PrecedentFrame+4;

	PrecedentFrame = CurrentFrame;

	return NbFramesLoupees;
}

/*
//
// Test de correction des Couleurs UV par KizKoool
//
// Paramtres :
// pQuelle      : Source
// pSauve       : Destination
// pColorQuelle : Rfrence pour reconstituer la couleur
// MasqueUV     : Masque de correction
//
int TestCorrectionUV(DWORD *pQuelle, DWORD *pSauve, DWORD *pColorQuelle,
DWORD MasqueUV)
{
    //unsigned long MasqueInverse;
	//DWORD *pix_courant;
	//MasqueInverse= ~MasqueUV;
	
/*

	for (pix_courant=pSauve; pix_courant<pSauve+(CurrentX>>1); pix_courant++)
	{
		*pix_courant=((*pQuelle & MasqueUV) | (*pColorQuelle & MasqueInverse));
		pColorQuelle++; pQuelle++;
	}
*//*
__asm
	{
		emms

		mov edi,pSauve //pix_courant
		mov esi,pQuelle

		mov eax,CurrentX
		mov edx,pColorQuelle

		shr eax,1
		movd mm7,MasqueUV
		
		movq mm6,mm7
		psllq mm7,32

		por mm7,mm6
		pcmpeqd mm0,mm0

		movq mm6,mm7

		lea eax,[eax+edi-8]//eax=pSauve+(CurrentX>>1)-8
		pxor mm6,mm0 //MasqueInverse;

		align 16
the_loop:
		movq mm0,qword ptr[esi] //*pQuelle
		
		movq mm1,qword ptr[edx]
		pand mm0,mm7

		pand mm1,mm6
		add edi,8

		por mm0,mm1
		add esi,8

		movq qword ptr[edi-8],mm0

		add edx,8
		cmp edi,eax

		jbe the_loop
		test edx,edx

		jz ok
		movd mm0,dword ptr[esi] //*pQuelle
		
		movd mm1,dword ptr[edx]
		pand mm0,mm7

		pand mm1,mm6

		por mm0,mm1

		movd dword ptr[edi],mm0

ok:
		emms
	}



	return LineSaturation(pSauve, CurrentX>>1,0,0,0);
}//*/


int TestCorrectionUV(DWORD *pQuelle, DWORD *pSauve, DWORD *pColorQuelle,
DWORD MasqueUV)
{
    unsigned long MasqueInverse;
	DWORD *pix_courant;
	MasqueInverse= ~MasqueUV;
	
	for (pix_courant=pSauve; pix_courant<pSauve+(CurrentX>>1); pix_courant++)
	{
		*pix_courant=((*pQuelle & MasqueUV) | (*pColorQuelle & MasqueInverse));
		pColorQuelle++; pQuelle++;
	}
	return LineSaturation(pSauve, CurrentX>>1,0,0,0);
}
//*/


// Deplac  l'exterieur du thread
int snab_compteur1=0;
extern int snab_paire, snab_attendtrame, snab_frame, nb_ligne_noire;	// dans deco.cpp

void Repetition50Trames()
{
	//Grincheux rptition 50 trames ***************** 
	snab_compteur1=NbFramesManquantes();
	type_trame_different=0;
	
	if ((snab_paire>2)&&(snab_paire<=49))
	{	
		
		if ((TypeImage_repet!=TypeImage))
		{
			snab_paire=100;
			type_trame_different=1;
		}
		
		if ((inversion_UV_0a31_Odd<3)&&((psort_odd>>7)%2==1))
		{
			snab_paire=100;
			type_trame_different=1;
		}
		
		if ((inversion_UV_0a31_Odd>14)&&((psort_odd>>7)%2==0))
		{
			snab_paire=100;
			type_trame_different=1;
		}
		

		if ((inversion_UV_0a31_Even<3)&&((psort_even>>7)%2==1))
		{
			snab_paire=100;
			type_trame_different=1;
		}

		if ((inversion_UV_0a31_Even>14)&&((psort_even>>7)%2==0))
		{
			snab_paire=100;
			type_trame_different=1;
		}
		
		
	}

	if ((snab_compteur1>0)&&(snab_paire<49)) 
		{snab_paire=100;
		type_trame_different=1;}

	if ((snab_compteur1>0)&&(snab_paire>49))
	{
		snab_attendtrame=400;//quand bascule  0 trop vite cela peut foirer ...? d'ou attend 2 fin de trame
							 // attention doit tre multiple de 100 sinon algo repet clef desactivee
		snab_paire=100;
		snab_frame=snab_frame%50;
	}

	//fin Grincheux rptition 50 trames *****************
}

/*
void Repetition50Trames()
{
	//Grincheux rptition 50 trames ***************** 
	snab_compteur1=NbFramesManquantes();
	if ((snab_compteur1>0)&&(snab_paire<49)) snab_paire=100;
	
	if ((snab_compteur1>0)&&(snab_paire>49))
	{
		snab_attendtrame=400;//quand bascule  0 trop vite cela peut foirer ...? d'ou attend 2 fin de trame
							 // attention doit tre multiple de 100 sinon algo repet clef desactivee
		snab_paire=100;
		snab_frame=snab_frame%50;
	}
	//fin Grincheux rptition 50 trames *****************
}
/*/
void Repetition25Trames()
{
	
	//Grincheux rptition 25 trames ***************** 
	snab_compteur1=NbFramesManquantes();
	type_trame_different=0;
	
	if ((snab_compteur1>0)&&(snab_paire>49))
	{
		snab_attendtrame=400;//quand bascule  0 trop vite cela peut foirer ...? d'ou attend 2 fin de trame
		snab_paire=100;
		snab_frame=snab_frame%50;
	}

	if ((snab_compteur1>0)&&(snab_paire<=49)) 
	{
		snab_paire=100; //test BUG5
		type_trame_different=1;
	}

	/* A debugger
	if ((snab_paire>20)&&(snab_paire<30))
	{	
		if ((inversion_UV_0a31_Even<3)&&((psort_even>>7)%2==1))
		{
			snab_paire=100;
			type_trame_different=1;
		}

		if ((inversion_UV_0a31_Even>14)&&((psort_even>>7)%2==0))
		{
			snab_paire=100;
			type_trame_different=1;
		}
	
	}
	/*/


	if (snab_paire<=48) 
	{
		snab_paire++; // on incrmente 1 trame supplmentaire (on saute la trame impaire)
	}
	snab_frame++;     // on incrmente 1 trame supplmentaire (on saute la trame impaire)
	snab_frame=snab_frame%50;
	//fin Grincheux rptition 25 trames *****************
}
